"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.coerceValue = void 0;
const boolean_1 = require("boolean");
function coerceValue(value, toType, defaultValue) {
    if (value === undefined) {
        return defaultValue;
    }
    if (value instanceof Array) {
        return value.map((v) => coerceValue(v, toType, undefined));
    }
    if (toType === Number) {
        return +value;
    }
    else if (toType === Boolean) {
        return (0, boolean_1.boolean)(value);
    }
    else {
        return value;
    }
}
exports.coerceValue = coerceValue;
