"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.value = exports.option = exports.command = void 0;
const commander_1 = require("./commander");
const meta = require("./metadata");
const command = (name, paramsClass, description) => {
    return (target) => {
        (0, commander_1.registerCommand)({
            name,
            description,
            type: target,
            paramsClass,
        });
    };
};
exports.command = command;
const option = (options) => (target, name) => {
    meta.addCommandOption(target, name, options);
};
exports.option = option;
const value = (options) => (target, name) => {
    meta.addCommandValue({
        name,
        paramsClassPrototype: target,
        optional: !!(options && options.optional),
        variadicType: options && options.variadic && options.variadic.type
    });
};
exports.value = value;
