"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getCommandUsageString = exports.execute = exports.commandsFromDirectory = exports.ioc = exports.versionFromPackage = exports.version = exports.value = exports.option = exports.command = void 0;
const classy_1 = require("./classy");
const commander_1 = require("./commander");
var decorators_1 = require("./decorators");
Object.defineProperty(exports, "command", { enumerable: true, get: function () { return decorators_1.command; } });
Object.defineProperty(exports, "option", { enumerable: true, get: function () { return decorators_1.option; } });
Object.defineProperty(exports, "value", { enumerable: true, get: function () { return decorators_1.value; } });
const commander = new classy_1.Commander();
// tslint:disable-next-line:no-shadowed-variable
function version(version) {
    return commander.version(version);
}
exports.version = version;
function versionFromPackage(dirName) {
    return commander.versionFromPackage(dirName);
}
exports.versionFromPackage = versionFromPackage;
function ioc(container) {
    return commander.ioc(container);
}
exports.ioc = ioc;
/**
 * Loads all commands within a directory so you don't need to require them individually.
 * @param directoryPath Directory path of the commands.
 */
function commandsFromDirectory(directoryPath) {
    return __awaiter(this, void 0, void 0, function* () {
        return commander.commandsFromDirectory(directoryPath);
    });
}
exports.commandsFromDirectory = commandsFromDirectory;
function execute(argv) {
    return __awaiter(this, void 0, void 0, function* () {
        return commander.execute(argv);
    });
}
exports.execute = execute;
function getCommandUsageString(commandClass) {
    return (0, commander_1.getCommandUsage)(commandClass);
}
exports.getCommandUsageString = getCommandUsageString;
