"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getUniqueModuleNames = void 0;
function isFileNameTypeScriptOrJavaScript(fileName) {
    return /.\.(ts|js)$/i.test(fileName);
}
function isFileNameDeclarationFile(fileName) {
    return /\.d.ts$/i.test(fileName);
}
function removeFileExtension(fileName) {
    return fileName.slice(0, -3);
}
function getUniqueModuleNames(fileNames) {
    const moduleNames = [
        ...new Set(fileNames
            .filter((filename) => !isFileNameDeclarationFile(filename))
            .filter(isFileNameTypeScriptOrJavaScript)
            .map(removeFileExtension)),
    ];
    return moduleNames;
}
exports.getUniqueModuleNames = getUniqueModuleNames;
